let express = require("express");
let path = require("path");
let app = express();
let server = require("http").createServer();
let WebSocketServer = require("ws").Server;
let Food = require("./include/food.js");
let Player = require("./include/player.js");
let wss =  new WebSocketServer({server:server});
let players = [];
let food = [];
let playercounter = 0;
app.use(express.static(path.join(__dirname,"/public")));
server.on("request",app);
server.listen(5000);
wss.on("connection", (ws)=>{
	console.log("Nový uživatel");
	let player = new Player(ws, playercounter++);
	players.push(player);
	ws.send(JSON.stringify({type:"init", data:player}));
	ws.on("close", ()=>{
		let index = players.indexOf(player);
		if (index >= 0) {
			players.splice(index, 1);
		}
	});
	ws.on("message", (message)=>{
		let json = JSON.parse(message);
		let type = json.type;
		let data = json.data;
		if (type == "updateDirection") {
			player.direction = data.direction;
		}
		else if (type == "updateName") {
			player.name = data;
		}
	});
});
setInterval(()=>{
	//console.table(players);
	let nplayers = [];
	for (let i = 0; i < players.length;i++){
		players[i].updatePosition();
		nplayers.push({
			id:players[i].id, 
			x:players[i].x,
			y:players[i].y,
			color:players[i].color,
			name:players[i].name,
			score:players[i].score,
			size:players[i].size
		});
	}
	for (let i = 0; i < nplayers.length;i++){
		console.log(process.memoryUsage().heapUsed / 1024 / 1024);
		let ofood = food.filter(f=>Math.sqrt(Math.pow(f.x - nplayers[i].x, 2) + Math.pow(f.y - nplayers[i].y, 2)) < nplayers[i].size / 2);
		for (let j = 0; j < ofood.length; j++) {
			food.splice(food.indexOf(ofood[j]), 1)
			players[i].sscore ++;
			
		}
		try{
			let oplayers = nplayers.filter(p=>Math.sqrt(Math.pow(p.x - nplayers[i].x, 2) + Math.pow(p.y - nplayers[i].y, 2)) < (nplayers[i].size - p.size ) / 2 && nplayers[i].size * 0.9 > p.size);
			for (let j = 0; j < oplayers.length; j++) {
				let index = nplayers.indexOf(oplayers[j]);
				let score = players[index].sscore;
				players[i].sscore += score;
				players.splice(index, 1);
				nplayers.splice(index, 1);



			}
		}catch(e){}
	}
	while(food.length < 400){
		let nf = new Food();
		let o = food.filter(f=>f.x == nf.x && f.y == nf.y);
		if (o.length == 0) {
			food.push(nf);
		}
	}
	for (let i = 0; i < players.length; i++){
		try{
			players[i].ws.send(JSON.stringify({
				type:"update", data:{
					players:nplayers, food:food
				}
			}));
		}catch(e){}
	}
	
}, 100);


