let game = document.querySelector(".game");
let ws = new WebSocket(location.origin.replace(/^http/,"ws"));
game.style.left = "200px";
let players = [];
let food = [];
let player = new Player(game);
players.push(player);
document.onmousemove = (e)=>{
	let x = e.clientX - window.innerWidth / 2;
	let y = e.clientY - window.innerHeight / 2;
	let direction = Math.atan2(y, x);
	player.direction = direction;
	console.log(direction);
}
ws.onmessage = (message)=>{
	let json = JSON.parse(message.data);
	let type = json.type;
	let data = json.data;
	if (type == "init") {
		player.x = data.x;
		player.y = data.y;
		player.id = data.id;
		player.color = data.color;
		player.score = data.score;
		player.size = data.size;
		let name = prompt("...");
		ws.send(JSON.stringify({
		type:"updateName",
		data:name
}));
	}
	else if (type == "update") {
		if (player.id == undefined) {
			return;
		}
		for (let i = 0; i < players.length; i++){
			players[i].updated = false;
		}
		for (let i = 0; i < data.players.length; i++){
			let p = players.filter(p => p.id == data.players[i].id)[0];
			if (p == undefined) {
				p = new Player(game);
				players.push(p);
				p.id = data.players[i].id;
				p.color = data.players[i].color;

			}
			p.size = data.players[i].size;
			p.score = data.players[i].score;
			p.x = data.players[i].x;
			p.y = data.players[i].y;	
			p.name = data.players[i].name;
			p.updated = true;	
		}
			for (let i = 0; i < players.length; i++){
			if (! players[i].updated){
				players[i].element.remove();
				players.splice(i, 1);
			}
		}
		for (let i = 0; i < food.length; i++) {
			food[i].updated = false;

		}
		for (let i = 0; i < data.food.length; i++){
			let f = food.filter(f => f.x == data.food[i].x && f.y == data.food[i].y)[0];
			if (f == undefined) {
				f = new Food(game);
				f.x = data.food[i].x;
				f.y = data.food[i].y;
				f.color = data.food[i].color;
				food.push(f);
			}
			f.updated = true;
		}
		for (let i = 0; i < food.length; i++) {
			if (! food[i].updated){
				food[i].element.remove();
				food.splice(i, 1);
			}
		}
		game.style.top = (window.innerHeight / 2 - player.y + 1000) + "px";
		game.style.left = (window.innerWidth / 2 - player.x + 1000) + "px";	
	}

};
setInterval(()=>{
	if (player.id == undefined) {
		return;
	}
	ws.send(JSON.stringify({
		type:"updateDirection",
		data:{
			direction:player.direction
		}
}));
}, 100);